% Same as FinalGradesDec21-b.m as of Dec20 2023
%The big change since F21 is:
% 1) plot Scores normalize by the total number of points NOT the maximum score

%Definitions of important variables
%NetID: String arrays 
%Names: String arrays of students first names
%sigma: standard deviations
%mu: means
%MaxScores: converted to % scores
%
%Scores: grades normalized to % units
%Mrow: row sorted mean in % units

clear all;close all
clc

if isfile('Xgrades.mat')  % Dont read grades.mat!!!
load grades.mat   %only works with matlab
else
disp(['read ascii grades.txt']);
data=importdata('493_grades-F23.csv',',',2);  %comma delim, with multiple tabs (\t) (!fails from octave)
%data=importdata('grades.txt',',',2);  %comma delim, with multiple tabs (\t) (!fails from octave)
%data=importdata('grades.orig',',',2);  %works best with data.textdata
%%data=importdata('Pruned.txt',',',2); %This is working but not data.textdata
disp(['save grades.mat']);
save grades.mat;
end

Nstuds=16;  %F22: 16 students F22
Nbins=Nstuds/2-1; 	%F22 Nbins should be prime
%Nbins=11;  % Less is better in F22

grades=data.data;    %collapse structure grades
TextData=data.textdata;
Names=string(TextData(2:end,1)); %names
NetID=string(TextData(2:end,2)); %NetID

% normalize raw --> Scores() in % re full scale
MaxScores=max(grades(:,1:2:5));  %Number of points
MaxPoints=[grades(1,2),grades(1,4),grades(1,6)];

%Dont need loop here on column vectors
%for k=1:Nstuds
%Next line a KEY modification in defining the final results
% Scores(:,1:3)= (100*[grades(:,1)./MaxScores(1), grades(:,3)./MaxScores(2), grades(:,5)./MaxScores(3)]); %Re: MaxScore
  Scores(:,1:3)= (100*[grades(:,1)./MaxPoints(1), grades(:,3)./MaxPoints(2), grades(:,5)./MaxPoints(3)]); %Re: MaxPoints (better)
%end

%disp([Scores]);
fig(1); 
hist(Scores(:,1),Nbins);
mu(1)=mean(grades(:,1));
sigma(1)=std(grades(:,1));
ylabel('\# Students');
xlim([30 100]);
str=sprintf('Exam-I: \x24\\mu =\x24% .3g, \x24\\sigma=\x24% .3g',round(mu(1)),round(sigma(1))) ;
title(str);
xlabel('score [raw]'); ylabel('\# Students');
drawnow
print -dpdf Exam1Stats


fig(2); 
hist(Scores(:,2),Nbins);
mu(2)=mean(grades(:,3));
sigma(2)=std(grades(:,3));
xlim([30 100]);
str=sprintf('Exam-II: \x24\\mu =\x24% .3g, \x24\\sigma=\x24% .3g',round(mu(2)),round(sigma(2))) ;
title(str);
xlabel('score [raw]'); ylabel('\# Students');
drawnow
print -dpdf Exam2Stats;


fig(3); 
hist(Scores(:,3),Nbins); 
title('Final');
ylabel('\# of students'); 
xlabel('Score \%');
mu(3)=mean(grades(:,5));
sigma(3)=std(grades(:,5));
xlim([30 100]);
str=sprintf('Final: \x24\\mu =\x24% .3g, \x24\\sigma=\x24% .3g',round(mu(3)),round(sigma(3))) ;
%title(str);
ylabel('\# Students');
xlabel('Score [raw]'); %for some unknown reason this line throughs a warning "Error updating Text"
drawnow
print -dpdf FinalStats

fig(5);
%hist([Scores(:,1)./90,grades(:,3)./91,grades(:,5)./157])
hist(Scores,Nbins); %Historgram of % grades
xlabel('Score [\%]'); ylabel('\# Students');
title('Historgram of all exams');

legend('Exam 1','Exam 2', 'Final','Location','NorthWest');
drawnow
print -dpdf SummaryHistogram

%Done with the three exams; now summarize
M = mean(Scores);
%M=zeros(Nstuds,3);
%M=grades(:,1:2:5); %Grades for Exam1,2 & Final for all students
%for i=1:Nstuds;
%disp(Names(i,1))
%%M(i,:)=[grades(i,1),grades(i,3),grades(i,5)]'
%disp([M(i), mean(M(i,:),2)])
%end


%compute row means for each student
Mrow=mean(Scores,2);  %Not that useful

%The mean(S) = sum(S.*W) if S(k) are the same.
%Example:
%W=[1 1 0]/2;
%scores=[100 100 0];
%Mu=mean(scores) %COlumn means

%Print out names and final scores, sorted from top to bottom
for k=1:Nstuds
name=char(Names(k));
str=sprintf('ID: %2d, Scores [%%]: [%4.1f %4.1f %4.1f]; mean [%%]=%4.1f, Name: %s',k, (Scores(k,:)),(Mrow(k)),name);
disp(str);
end


%I decided not to weigh the scores because almost everyone went down, especialy Dias
%disp('Weighted % scores');
%W=[2 2 3]/5;% weights not used in F22
%[mean(Scores),sum(Scores.*W)]

%Try to find the break points for the scores from the sorted scores

%Mrow=round(Mrow); %Added this Dec 23 @ 11:19 AM

fig(19);
[MrowSorted,ksort] = sort(Mrow);
rsort=flip(ksort);  %reverse the order to make it easier to tabulate
plot(MrowSorted,'o--');grid on; 
xlabel('Student'); ylabel('Sorted Scores [%]'); title('3-Exam Avg [%]');
hold on; 
%fig(18);
%plot([10,Nstuds],[85 85],'--r');  %Put dashed line for A+ to A break 
plot([7 14],[85 85],'--r');
plot([4 8],[80 80],'-k');
plot([2 7],[72 72],'--m');
%plot([0 3],[70 70],'-m');
print -dpdf SortedScores
drawnow

AP=1:3; %A+
A=4:7; %A
Am=8:12; %A-
BP=13:14; %B+
B=15:16; %B
%BM=14:16; %B-

%pause(1);

disp(' ');
disp('    A+')
for k=rsort(1:4)'
    clear(name);
name=char(Names(k,:));
str=sprintf('ID: %2d, Scores [%%]: [%4.1f %4.1f %4.1f]; mean [%%]=%4.1f, Name: %s',k,(Scores(k,:)),(Mrow(k)),name);
disp(str);
end
disp(' ');

disp('    A')
for k=rsort(5:8)'
    clear(name);
name=char(Names(k,:));
str=sprintf('ID: %2d, Scores [%%]: [%4.1f %4.1f %4.1f]; mean [%%]=%4.1f, Name: %s',k,(Scores(k,:)),(Mrow(k)),name);
disp(str);
end
disp(' ');

disp('    A-')
for k=rsort(9:14)'
    clear(name);
name=char(Names(k,:));
str=sprintf('ID: %2d, Scores [%%]: [%4.1f %4.1f %4.1f]; mean [%%]=%4.1f, Name: %s',k,(Scores(k,:)),(Mrow(k)),name);
disp(str);
end
disp(' ');

disp('    B')
for k=rsort(15)'
    clear(name);
name=char(Names(k,:));
str=sprintf('ID: %2d, Scores [%%]: [%4.1f %4.1f %4.1f]; mean [%%]=%4.1f, Name: %s',k,(Scores(k,:)),(Mrow(k)),name);
disp(str);
end
disp(' ');

disp('    C');
for k=rsort(16)'
    clear(name);
name=char(Names(k,:));
str=sprintf('ID: %2d, Scores [%%]: [%4.1f %4.1f %4.1f]; mean [%%]=%4.1f, Name: %s',k,(Scores(k,:)),(Mrow(k)),name);
disp(str);
end
disp(' ');

%disp('    B-');
%k=rsort(22);
%    clear(name);
%name=char(Names(k,:));
%str=sprintf('ID: %2d, Scores [%%]: [%4.1f %4.1f %4.1f]; mean [%%]=%4.1f, Name: %s',k,(Scores(k,:)),(Mrow(k)),name);
%disp([str]);

